unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, uKeyEmulate, StdCtrls, UTrayIcon, Menus, ShellAPI;

type
  TfMain = class(TForm)
    cbChar: TComboBox;
    cbShift: TCheckBox;
    cbControl: TCheckBox;
    lbHotKey: TListBox;
    Button1: TButton;
    Button2: TButton;
    Bevel1: TBevel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    cbCharA: TComboBox;
    lbEmulateKey: TListBox;
    Button3: TButton;
    Button4: TButton;
    tiTray: TTrayIcon;
    PopupMenu1: TPopupMenu;
    cbTimer: TCheckBox;
    eTimer: TEdit;
    cbTypeAct: TComboBox;
    Button6: TButton;
    Button7: TButton;
    Button5: TButton;
    cbWin: TCheckBox;
    Button8: TButton;
    procedure FormCreate(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure lbHotKeyClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button8MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    procedure WMHotKey(var msg:TWMHotKey);message WM_HotKey;
    procedure WMOnActivate(var msg:TWMActivateApp);message WM_ACTIVATEAPP;
  public
    { Public declarations }
  end;

  TActionType=(Down,Up,Stroke,Say);
  TTimerType=(None,Started,Stopped);

  TAction=record
    _Type:TActionType;
    _Char:byte;
    _String:string;
  end;

  TMyHotKey=object
    ID:integer;
    _Timer:TTimerType;
    Timer:TTimer;
    _Shift:boolean;
    _Control:boolean;
    _Win:boolean;
    _Char:Char;
    Actions:array of TAction;
    procedure Go(Sender: TObject);
  end;

var
  fMain: TfMain;
  HotKeys:array of TMyHotKey;
  StopAll:boolean;

implementation

uses Math;

{$R *.dfm}

procedure TfMain.WMHotKey(var msg: TWMHotKey);
var i:byte;
begin
  if Length(HotKeys)=0 then exit;
  for i:=0 to Length(HotKeys)-1 do
  if msg.HotKey=HotKeys[i].ID then begin
    case HotKeys[i]._Timer of
      None:HotKeys[i].Go(nil);
      Started:begin
        HotKeys[i]._Timer:=Stopped;
        HotKeys[i].Timer.Enabled:=false;
      end;
      Stopped:begin
        HotKeys[i]._Timer:=Started;
        HotKeys[i].Timer.Enabled:=true;
      end;
    end;
    break;
  end;
end;

procedure TfMain.FormCreate(Sender: TObject);
var MenuHandle:HMENU;
    i:char;
    j:byte;
begin
  randomize;
  MenuHandle:=GetSystemMenu(Handle,false);
  if MenuHandle<>0 then
  DeleteMenu(MenuHandle,SC_MAXIMIZE,MF_BYCOMMAND);
  tiTray.TrayIcon:=Application.Icon;
  tiTray.TrayShow;
  for i:='A' to 'Z' do begin
    cbChar.Items.Add(i);
  end;
  for i:='0' to '9' do begin
    cbChar.Items.Add(i);
  end;
  cbCharA.Items.Assign(cbChar.Items);

  for j:=12 downto 1 do
  cbCharA.Items.Insert(0,'F'+inttostr(j));

  cbCharA.Items.Insert(0,'Ctrl');
  cbCharA.Items.Insert(0,'Alt');
  cbCharA.Items.Insert(0,'Shift');
  cbCharA.Items.Insert(0,'Win');
end;

procedure TfMain.PopupMenu1Popup(Sender: TObject);
begin
  Application.Restore;
end;

procedure TfMain.FormDestroy(Sender: TObject);
var i:byte;
begin
  if length(HotKeys)>0 then
  for i:=0 to length(HotKeys)-1 do
  try
    if HotKeys[i]._Timer<>None then HotKeys[i].Timer.Free;
    UnregisterHotKey(Handle,HotKeys[i].ID);
  except end;
  tiTray.TrayHide;
end;

procedure TfMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_F1 then begin
    Application.Minimize;
    ShowWindow(Application.Handle,SW_HIDE);
  end;
end;

procedure TfMain.Button1Click(Sender: TObject);
var tmp:string;
    tmpID:integer;
begin
  if cbChar.ItemIndex=-1 then exit;
  tmp:='';
  SetLength(HotKeys,length(HotKeys)+1);
  //  
  if cbControl.Checked then begin
    tmp:=tmp+'Ctrl ';
    HotKeys[Length(HotKeys)-1]._Control:=true;
  end;
  //  
  if cbShift.Checked then begin
    tmp:=tmp+'Shift ';
    HotKeys[Length(HotKeys)-1]._Shift:=true;
  end;
  //  
  if cbWin.Checked then begin
    tmp:=tmp+'Win ';
    HotKeys[Length(HotKeys)-1]._Win:=true;
  end;
  // 
  HotKeys[Length(HotKeys)-1]._Char:=cbChar.text[1];
  tmp:=tmp+cbChar.Text;
  //    
  if cbTimer.Checked then begin
    HotKeys[Length(HotKeys)-1].Timer:=TTimer.Create(nil);
    HotKeys[Length(HotKeys)-1].Timer.Enabled:=false;
    HotKeys[Length(HotKeys)-1].Timer.OnTimer:=
    HotKeys[Length(HotKeys)-1].Go;
    try
      HotKeys[Length(HotKeys)-1].Timer.Interval:=StrToInt(eTimer.Text);
    except
      HotKeys[Length(HotKeys)-1].Timer.Interval:=10000;
    end;
    tmp:=tmp+' ('+eTimer.Text+')';
    HotKeys[Length(HotKeys)-1]._Timer:=Stopped;
  end
  else HotKeys[Length(HotKeys)-1]._Timer:=None;
  //    
  tmpID:=GlobalAddAtom(PChar(inttostr(RandomRange(10000000,99999999))));
  with HotKeys[Length(HotKeys)-1] do
  RegisterHotKey(Handle,tmpID,
  (MOD_SHIFT * byte(_Shift)) or
  (MOD_CONTROL * byte(_Control)) or
  (MOD_WIN * byte(_Win)),ord(_Char));
  HotKeys[Length(HotKeys)-1].ID:=tmpID;
  lbHotKey.Items.Add(tmp);
  Button7.Enabled:=false;
end;

procedure TfMain.Button2Click(Sender: TObject);
begin
  if lbHotKey.ItemIndex=-1 then exit;
  if HotKeys[lbHotKey.ItemIndex]._Timer<>None then
  try
    HotKeys[lbHotKey.ItemIndex].Timer.Free;
  except end;

  UnregisterHotKey(Handle,HotKeys[lbHotKey.ItemIndex].ID);
  GlobalDeleteAtom(HotKeys[lbHotKey.ItemIndex].ID);

  HotKeys[lbHotKey.ItemIndex]:=HotKeys[Length(HotKeys)-1];
  SetLength(HotKeys,Length(HotKeys)-1);

  lbHotKey.Items[lbHotKey.ItemIndex]:=lbHotKey.Items[lbHotKey.Count-1];
  lbHotKey.Items.Delete(lbHotKey.Count-1);

  lbEmulateKey.Clear;
end;

{ TMyHotKey }

procedure TMyHotKey.Go(Sender: TObject);
var i:byte;
begin
  if(Length(Actions)=0)or(StopAll)then exit;
  SimulateKeyUp(VK_LWIN);
  SimulateKeyUp(VK_SHIFT);
  SimulateKeyUp(VK_MENU);
  SimulateKeyUp(VK_CONTROL);
  for i:=0 to Length(Actions)-1 do
  case Actions[i]._Type of
    Down:SimulateKeyDown(Actions[i]._Char);
    Up:SimulateKeyUp(Actions[i]._Char);
    Stroke:SimulateKeystroke(Actions[i]._Char);
    Say:begin
      SimulateKeystroke(VK_RETURN);
      SimulateKeys(Actions[i]._String);
      SimulateKeystroke(VK_RETURN);
    end;
  end;
end;

procedure TfMain.Button3Click(Sender: TObject);
begin
  if(cbCharA.ItemIndex=-1)or(lbHotKey.ItemIndex=-1)then exit;

  with HotKeys[lbHotKey.ItemIndex] do begin
    SetLength(Actions,Length(Actions)+1);
    case cbTypeAct.ItemIndex of
      0:Actions[length(Actions)-1]._Type:=Down;
      1:Actions[length(Actions)-1]._Type:=Up;
      2:Actions[length(Actions)-1]._Type:=Stroke;
    end;

    case cbCharA.ItemIndex of
      0:Actions[length(Actions)-1]._Char:=VK_LWIN;
      1:Actions[length(Actions)-1]._Char:=VK_SHIFT;
      2:Actions[length(Actions)-1]._Char:=VK_MENU;
      3:Actions[length(Actions)-1]._Char:=VK_CONTROL;
      4..15:Actions[length(Actions)-1]._Char:=VK_F1+(cbCharA.ItemIndex-4);
    else Actions[length(Actions)-1]._Char:=ord(cbCharA.Text[1]);
    end;

    lbEmulateKey.Items.Add(cbTypeAct.Text+' '+cbCharA.Text);
  end;
end;

procedure TfMain.Button4Click(Sender: TObject);
var i,j:integer;
begin
  i:=lbHotKey.ItemIndex;
  j:=lbEmulateKey.ItemIndex;
  if(i=-1)or(j=-1)then exit;
  SetLength(HotKeys[i].Actions,length(HotKeys[i].Actions)-1);
  lbEmulateKey.Items.Delete(lbEmulateKey.Count-1);
end;

procedure TfMain.WMOnActivate(var msg: TWMActivateApp);
begin
  StopAll:=msg.Active;
end;

procedure TfMain.Button5Click(Sender: TObject);
var tmp:string;
begin
  if(lbHotKey.ItemIndex=-1)then exit;
  if not InputQuery('   Lineage II','',tmp) then exit;
  with HotKeys[lbHotKey.ItemIndex] do begin
    SetLength(Actions,Length(Actions)+1);
    Actions[length(Actions)-1]._Type:=Say;
    Actions[length(Actions)-1]._String:=tmp;
    lbEmulateKey.Items.Add('Say: '+tmp);
  end;              
end;

procedure TfMain.lbHotKeyClick(Sender: TObject);
var i,j:integer;
    tmp:string;
begin
  i:=lbHotKey.ItemIndex;
  if i=-1 then exit;
  lbEmulateKey.Clear;
  if length(HotKeys[i].Actions)=0 then exit;
  for j:=0 to length(HotKeys[i].Actions)-1 do begin
    tmp:='';
    case HotKeys[i].Actions[j]._Char of
      VK_LWIN:tmp:='Win';
      VK_SHIFT:tmp:='Shift';
      VK_MENU:tmp:='Alt';
      VK_CONTROL:tmp:='Control';
      VK_F1..VK_F12:tmp:='F'+inttostr(HotKeys[i].Actions[j]._Char-VK_F1+1);
    else
      tmp:=char(HotKeys[i].Actions[j]._Char);
    end;
    case HotKeys[i].Actions[j]._Type of
      Down:tmp:=' '+tmp;
      Up:tmp:=' '+tmp;
      Stroke:tmp:='+ :) '+tmp;
      Say:tmp:='Say: '+HotKeys[i].Actions[j]._String;
    end;
    lbEmulateKey.Items.Add(tmp);
  end;
end;

procedure TfMain.Button6Click(Sender: TObject);
var F,i,j,k:integer;
    buf:cardinal;
begin
  f:=FileCreate(ExtractFilePath(ParamStr(0))+'Settings');
  if Length(HotKeys)=0 then exit;
  buf:=Length(HotKeys); FileWrite(f,buf,1);
  for i:=0 to Length(HotKeys)-1 do begin
    buf:=byte(HotKeys[i]._Timer); FileWrite(f,buf,1);
    if HotKeys[i]._Timer<>None then buf:=HotKeys[i].Timer.Interval
    else buf:=0;
    FileWrite(f,buf,4);
    buf:=byte(HotKeys[i]._Shift); FileWrite(f,buf,1);
    buf:=byte(HotKeys[i]._Control); FileWrite(f,buf,1);
    buf:=byte(HotKeys[i]._Win); FileWrite(f,buf,1);
    buf:=byte(HotKeys[i]._Char); FileWrite(f,buf,1);
    buf:=Length(HotKeys[i].Actions); FileWrite(f,buf,1);
    if Length(HotKeys[i].Actions)<>0 then
    for j:=0 to Length(HotKeys[i].Actions)-1 do begin
      buf:=byte(HotKeys[i].Actions[j]._Type);
      FileWrite(f,buf,1);
      if HotKeys[i].Actions[j]._Type=Say then begin
        buf:=Length(HotKeys[i].Actions[j]._String);
        FileWrite(f,buf,1);
        for k:=1 to Length(HotKeys[i].Actions[j]._String)do begin
          buf:=byte(HotKeys[i].Actions[j]._String[k]);
          FileWrite(f,buf,1);
        end;
      end
      else begin
        buf:=0; FileWrite(f,buf,1);
        buf:=HotKeys[i].Actions[j]._Char; FileWrite(f,buf,1);
      end;
    end;
  end;
  FileClose(f);
  Button7.Enabled:=false;
end;

procedure TfMain.Button7Click(Sender: TObject);
var i,j,k,buf:cardinal;
    F,HL,AL,tmpID,StrLen_:integer;
    tmp:string;
begin
  f:=FileOpen(ExtractFilePath(ParamStr(0))+'Settings',fmOpenRead);
  if f=-1 then exit;
  FileRead(f,HL,1);
  SetLength(HotKeys,HL);
  for i:=0 to HL-1 do begin
    FileRead(f,buf,1); HotKeys[i]._Timer:=TTimerType(buf);
    FileRead(f,buf,4);
    if HotKeys[i]._Timer<>None then begin
      HotKeys[i].Timer:=TTimer.Create(nil);
      HotKeys[i].Timer.Interval:=buf;
      HotKeys[i].Timer.Enabled:=false;
      HotKeys[i].Timer.OnTimer:=HotKeys[i].Go;
    end;
    FileRead(f,buf,1); HotKeys[i]._Shift:=boolean(buf);
    FileRead(f,buf,1); HotKeys[i]._Control:=boolean(buf);
    FileRead(f,buf,1); HotKeys[i]._Win:=boolean(buf);
    FileRead(f,buf,1); HotKeys[i]._Char:=Char(buf);
    FileRead(f,AL,1);
    if AL>0 then begin
      SetLength(HotKeys[i].Actions,AL);
      for j:=0 to AL-1 do begin
        FileRead(f,buf,1);
        HotKeys[i].Actions[j]._Type:=TActionType(buf);
        FileRead(f,buf,1);
        if byte(buf)>0 then begin
          StrLen_:=byte(buf);
          HotKeys[i].Actions[j]._String:='';
          for k:=1 to StrLen_ do begin
            FileRead(f,buf,1);
            HotKeys[i].Actions[j]._String:=
            HotKeys[i].Actions[j]._String+char(buf);
          end;
        end
        else begin
          FileRead(f,buf,1);
          HotKeys[i].Actions[j]._Char:=buf;
        end;
      end;                                                       
    end;
    tmpID:=GlobalAddAtom(PChar(inttostr(RandomRange(10000000,99999999))));
    with HotKeys[i] do
    RegisterHotKey(Handle,tmpID,
    (MOD_SHIFT * byte(_Shift)) or
    (MOD_CONTROL * byte(_Control)) or
    (MOD_WIN * byte(_Win)),ord(_Char));
    HotKeys[i].ID:=tmpID;
  end;
  FileClose(f);

  tmp:='';
  for i:=0 to length(HotKeys)-1 do begin
    tmp:='';
    //  
    if HotKeys[i]._Control then tmp:=tmp+'Ctrl ';
    //  
    if HotKeys[i]._Shift then tmp:=tmp+'Shift ';
    //  
    if HotKeys[i]._Win then tmp:=tmp+'Win ';
    // 
    tmp:=tmp+HotKeys[i]._Char;
    //    
    if HotKeys[i]._Timer<>None then
    tmp:=tmp+' ('+inttostr(HotKeys[i].Timer.Interval)+')';
    lbHotKey.Items.Add(tmp);
  end;
  Button7.Enabled:=false;
end;

procedure TfMain.Button8Click(Sender: TObject);
begin
  ShellExecute(0,nil,PChar(ExtractFilePath(ParamStr(0))+'Help.hlp'),
  nil,nil,SW_SHOWMAXIMIZED);
end;

procedure TfMain.Button8MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  StaticText1.SetFocus;
end;

end.
